;{ save & load (preferences, preset, img..)

Procedure openAppli()
  If OpenPreferences("options.ini")
    PreferenceGroup("general")  
    lang$ = ReadPreferenceString("lang","fr") 
    color = ReadPreferenceInteger("Color_FG",0)  
    color_BG = ReadPreferenceInteger("Color_BG",RGB(255,255,255))  
    color_R = Red(color)
    color_G = Green(color)
    color_B = Blue(color) 
    doc_w = ReadPreferenceInteger("doc_w",2000) 
    doc_h = ReadPreferenceInteger("doc_h",2000) 
    
    PreferenceGroup("brush")
    ; read the preferences
    brush_dir$ = ReadPreferenceString("brush_directory","brush\blendman")
    brushId = ReadPreferenceInteger("brush",1)
    space = ReadPreferenceInteger("space",1)
    size = ReadPreferenceInteger("size",1)
    transparence = ReadPreferenceInteger("transparence",255)
    tool = ReadPreferenceInteger("tool",1)
    size_mini = ReadPreferenceInteger("size_mini",50)
    viscosity = ReadPreferenceInteger("viscosity",1)
    mix1 = ReadPreferenceInteger("mix",15)
    mix = mix1/100
    mik_ok = WritePreferenceInteger("mix_ok",1)
    sizeW = ReadPreferenceInteger("sizeW",100)
    sizeH = ReadPreferenceInteger("sizeH",100)

    ClosePreferences()
    menu = tool    
  Else
    MessageRequester("Erreur","Impossible de charger le fichier Prfrence",#MB_ICONERROR)
  EndIf
    Debug Str(doc_w)+" / "+Str(doc_h)
EndProcedure
Procedure closeAppli()  
  If OpenPreferences("options.ini")
    PreferenceGroup("general")
    WritePreferenceString("lang",lang$)
    WritePreferenceString("version",version$)
    WritePreferenceInteger("Color_FG",color)
    WritePreferenceInteger("Color_BG",color_BG)
    
    PreferenceGroup("brush")  
    WritePreferenceString("brush_directory",brush_dir$)
    WritePreferenceInteger("brush",brushId)
    WritePreferenceInteger("space",space)
    WritePreferenceInteger("size",size)
    WritePreferenceInteger("sizeW",sizeW)
    WritePreferenceInteger("sizeH",sizeH)    
    WritePreferenceInteger("transparence",transparence)
    WritePreferenceInteger("tool",tool)
    WritePreferenceInteger("size_mini",size_mini) 
    WritePreferenceInteger("viscosity",viscosity) 
    WritePreferenceInteger("mix_ok",mix_ok) 
    WritePreferenceInteger("mix",mix1) 
     
    ClosePreferences()
  Else
    MessageRequester("Erreur","Impossible d'enregistrer le fichier Prfrence",#MB_ICONERROR)
  EndIf
EndProcedure

Procedure marge()
  ; the marge on the scrollarea, for the canvas
  If doc_w >=doc_h
      marge =  Abs((WindowWidth(0) - doc_w)/2)
  Else  
      marge = Abs((WindowHeight(0)- doc_h)/2)
  EndIf  
  EndProcedure

Procedure loadpreset()
EndProcedure
Procedure savepreset()
EndProcedure

Procedure ImportImg_Aslayer()
  file$ =OpenFileRequester("Recherche", "","Fichiers Images|*.jpg;*.jpeg;*.png;*.bmp;*.tga;*.tiff",0)
  If file$ <>""
    LoadImage(#importImg,file$)   
    StartDrawing(ImageOutput(current_layer))  
    DrawingMode(#PB_2DDrawing_AlphaBlend)   
    DrawAlphaImage(ImageID(#importImg),0,0)      
    StopDrawing()
  EndIf
EndProcedure

Procedure Export_Img_png()
  ; export all the layers in png
  file$ =SaveFileRequester("Enregistrer", "","Images PNG|*.png",0)
  If file$ <>""    
    CreateImage(#IMAGE_LoadSave,doc_w,doc_h,32)
    StartDrawing(ImageOutput(#IMAGE_LoadSave)) 
    DrawingMode(#PB_2DDrawing_AlphaChannel)
    Box(0,0,doc_w,doc_h,RGBA(0,0,0,0))
    DrawingMode(#PB_2DDrawing_AlphaBlend) 
    If backgroundCanvas = 1
      DrawImage(ImageID(#canvasBG),0,0)
    EndIf  
    DrawingMode(#PB_2DDrawing_AlphaBlend)
    ForEach layers()
      If layers()\visible = 1
        DrawAlphaImage(ImageID(layers()\id),0,0)
      EndIf    
    Next             
    StopDrawing()  
    
    If GetExtensionPart(file$)=""
      ext$ =".png"
    EndIf 
   
    SaveImage(#IMAGE_LoadSave,file$+ext$,#PB_ImagePlugin_PNG) 
    FreeImage(#IMAGE_LoadSave)
  EndIf
EndProcedure
Procedure export_Img_jpg()
  ; export all the layers in jpg
  qualite = Val(InputRequester("Compression", "Dfinir la qualit de l'image (0  10)","10"))
  If qualite< 0
    qualite = 0
  ElseIf qualite> 10
    qualite = 10
  EndIf
  file$ =SaveFileRequester("Enregistrer", "","Images JPG|*.jpg",0)
  If file$ <>""
    CreateImage(#IMAGE_LoadSave,doc_w,doc_h,32)    
    StartDrawing(ImageOutput(#IMAGE_LoadSave)) 
    DrawingMode(#PB_2DDrawing_AlphaChannel)
    Box(0,0,doc_w,doc_h,RGBA(0,0,0,0))         
    If backgroundCanvas = 1
      DrawImage(ImageID(#canvasBG),0,0)
    EndIf  
    DrawingMode(#PB_2DDrawing_AlphaBlend)
    ForEach layers()
      If layers()\visible = 1
        DrawAlphaImage(ImageID(layers()\id),0,0)
      EndIf    
    Next             
    StopDrawing()            
    
    If GetExtensionPart(file$)=""
      ext$ =".jpg"
    EndIf      
    
    SaveImage(#IMAGE_LoadSave,file$+ext$,#PB_ImagePlugin_JPEG,qualite) 
    FreeImage(#IMAGE_LoadSave)
  EndIf  
EndProcedure
Procedure Export_layer_png()
  ; export the active layer in png with transparence
  file$ =SaveFileRequester("Enregistrer", "","Images PNG|*.PNG",0)
  If file$ <>""
    CreateImage(#IMAGE_LoadSave,doc_w,doc_h,32)
    
    StartDrawing(ImageOutput(#IMAGE_LoadSave)) 
    DrawingMode(#PB_2DDrawing_AlphaChannel)
    Box(0,0,doc_w,doc_h,RGBA(0,0,0,0))
    DrawingMode(#PB_2DDrawing_AlphaBlend) 
    DrawAlphaImage(ImageID(current_layer),0,0)             
    StopDrawing()  
    
    If GetExtensionPart(file$)=""
      ext$ =".png"
    EndIf             
    SaveImage(#IMAGE_LoadSave,file$+ext$,#PB_ImagePlugin_PNG) 
    FreeImage(#IMAGE_LoadSave)
  EndIf
EndProcedure

Procedure Open_doc()
  file$=OpenFileRequester("Ouvrir","Ouvrir un fichier Animatoon","Animatoon (.abi)|*.abi",0)
  If file$<>""    
  EndIf  
EndProcedure
Procedure save_doc()
  
  file$=SaveFileRequester("Sauvegarder","","Animatoon (.abi)|*.abi",0)
  If file$<>""
    ;If CheckFilename(file$)
      
      If GetExtensionPart(file$)=""
        file$ +".abi"
      EndIf  
      OpenFile(0,file$)
      WriteStringN(0,"; Fichier animatoon "+version$)
      WriteStringN(0,"Nb_layer = "+Str(ListSize(layers())))
      i=1
      ForEach layers()
        WriteStringN(0,"[Layer" +Str(i)+"]")
        WriteStringN(0,"Name = " +layers()\name$)      
        WriteStringN(0,"Numero = "+Str(layers()\id-500))
        WriteStringN(0,"Blendmode = "+Str(layers()\blendmode))
        WriteStringN(0,"Opacity = "+Str(layers()\opacity))
        WriteStringN(0,"Position = "+Str(layers()\position))
        WriteStringN(0,"Visible = "+Str(layers()\visible))
        WriteStringN(0,"Locked = "+Str(layers()\locked))
        WriteStringN(0,"Image = "+Str(layers()\IG_LayerMenu))      
        i+1
      Next
      
      CloseFile(0)
      
      docname$ = GetFilePart(file$)
      If SetWindowTitle(0,"Animatoon "+version$+" - ["+docname$+"]") = 0  : MessageRequester("Erreur","Impossible d'afficher le titre",#MB_ICONERROR) : EndIf
;     Else
;       MessageRequester("Error", "Wrong Filename for the the file")
;     EndIf    
  EndIf 
EndProcedure
;}

;{ UI & WINDOW
; Interface creation (macro or other usefull procedure to avoid repeat code)
Procedure ImageLoad2(nb,file$,w=25,h=25)
If LoadImage(nb,file$) =0
  MessageRequester("Erreur", "Impossible d'ouvrir l'image "+file$)
  CreateImage(nb,w,h)  
EndIf
EndProcedure
Macro new_window(number, nom="",w = 400,h = 300)
  flag = #PB_Window_SystemMenu|#PB_Window_TitleBar|#PB_Window_WindowCentered  
  firstopen = 2
  If OpenWindow(number, x,y, w, h, nom, flag,WindowID(0))
  EndIf  
EndMacro

; menu & new window
Procedure Doc_new()
  ; on cre la fentre
  new_window(20, "Nouveau Document")
  ; l'intrieur de la fentre
  pixel_x = 640
  pixel_y = 480
  reso = 72
  TextGadget(1114,10,10,50,50, "Nom :")
  StringGadget(1125, 40, 10, 200, 20, "")
  
  Frame3DGadget(1110, 10, 30, 300, 130, "Image")
  
  TextGadget(1111,0,60,80,20,"Largeur : ", #PB_Text_Right) 
  StringGadget(1116, 100,  60, 55, 20, Str(pixel_x), #PB_String_Numeric)
  TextGadget(1112,0,80,80,20,"Hauteur : ", #PB_Text_Right) 
  StringGadget(1117, 100,  80, 55, 20, Str(pixel_y), #PB_String_Numeric)
  TextGadget(1113,0,100,80,20,"Rsolution : ", #PB_Text_Right) 
  StringGadget(1118, 100,  100, 55, 20, Str(reso), #PB_String_Numeric)      
  
  poids = pixel_x*pixel_y*3
  oct$ = "Ko"
  If poids <1000
    poids = 1
  ElseIf poids > 1000 And poids<1000000
    poids =Round(poids /1000,1)
  ElseIf poids >1000000
    poids = Round(poids/100000,1)
    oct$="Mo"
  EndIf
  
  TextGadget(1115,0,120,80,20,"Taille : ", #PB_Text_Right)
  TextGadget(1119,105,120,100,20,Str(poids)+" "+oct$)
  TextGadget(1126,0,140,80,20,"Mode : ", #PB_Text_Right) 
  
  Frame3DGadget(1120, 10, 180, 300, 110, "Remplir avec :")
  OptionGadget(1121, 20,200,150,20,"Blanc")
  OptionGadget(1127, 20,220,150,20,"Couleur d'arrire-plan")
  OptionGadget(1123, 20,240,150,20,"Couleur d'avant-plan")
  OptionGadget(1124, 20,260,150,20,"Transparent")
  
  ButtonGadget(1108,320,20,70,25,"Ok")
  ButtonGadget(1109,320,50,70,25,"Annuler")
  ;StickyWindow(20,1) 
  
  
  quitt.b
  
  Repeat
    event2 = WaitWindowEvent()
    SetActiveWindow(20)
    
    Select event2
        
      Case #PB_Event_CloseWindow 
        If GetActiveWindow() <> 0         
          CloseWindow(GetActiveWindow())
          open_menu = 0
        EndIf
        
      Case #PB_Event_Gadget
        Select EventGadget()
            
          Case 1108
            CloseWindow(GetActiveWindow())
            quitt = 1
            
          Case 1109
            CloseWindow(GetActiveWindow())
            quitt = 1
            
        EndSelect    
        
    EndSelect
    
  Until quitt = 1 Or event2 = #PB_Event_CloseWindow 
  open_menu = 0
  firstopen = 1
EndProcedure
Procedure open_pref()
  new_window(146,"Preference",400,300)
  
  TextGadget(1110,20,10,80,20, dico("Lang"))
  ComboBoxGadget(1111,120,10,120,20)
  AddGadgetItem(1111, 0,"English")
  AddGadgetItem(1111, 1,"Franais")
  ;SetGadgetState(1111, 0)

  
  ButtonGadget(1108,320,20,70,25,dico("Btn_ok"))
  ButtonGadget(1109,320,50,70,25,dico("Btn_cancel"))
  quitt.b  
  ;{ loop
  Repeat
    event2 = WaitWindowEvent()
    SetActiveWindow(146)
    
    Select event2        
      Case #PB_Event_CloseWindow 
        If GetActiveWindow() <> 0         
          CloseWindow(GetActiveWindow())
          open_menu = 0
        EndIf        
      Case #PB_Event_Gadget
        Select EventGadget()            
          Case 1108
            CloseWindow(GetActiveWindow())
            quitt = 1            
          Case 1109
            CloseWindow(GetActiveWindow())
            quitt = 1 
          Case 1111
            lang=GetGadgetState(1111)
            If lang = 0
              lang$ = "eng"
            ElseIf lang = 1
              lang$ = "fr"
            EndIf
            
        EndSelect    
        
    EndSelect
    
  Until quitt = 1 Or event2 = #PB_Event_CloseWindow 
  open_menu = 0
  firstopen = 1
  ;}
  
EndProcedure
Procedure open_dynEd()
  new_window(118,"Brush Animated",400,300)
  pixel_x = 640
  pixel_y = 480
  reso = 72
  DirectoryBrush$ ="brush\brushAnim1\"
  BrushAnimId =1
  LoadImage(5000,DirectoryBrush$+Str(BrushAnimId)+".png")
  CreateImage(4999,80,80,32)
  ResizeImage(5000,80,80)
  StartDrawing(ImageOutput(4999))
  Box(0,0,80,80,RGB(125,125,125))
  For i=0 To 2
      For j = 0 To 2
        DrawAlphaImage(ImageID(#motif_canvas),i*64,j*64)
      Next j  
    Next i
    DrawingMode(#PB_2DDrawing_AlphaBlend)
    DrawAlphaImage(ImageID(5000),0,0)
  StopDrawing()
  
 
  ImageGadget(1111, 10,10,80,80,ImageID(4999))
  TextGadget(1112,100,10,50,20, "Nom :")
  StringGadget(1113,130, 7, 150, 20, "")
  
  TextGadget(1115,100,35,40,20,"Dossier: ") 
  StringGadget(1116, 160,  35, 120, 20, DirectoryBrush$)
  ButtonImageGadget(1118,280,35,20,20,ImageID(#Img_btn_newlayer))
  
  CheckBoxGadget(1114,100,55,80,20,"Preview Anim")
  CheckBoxGadget(1117,100,75,110,20,"Lecture Random")
  ;CheckBoxGadget(1122,100,70,100,20,"Brush anim")
  
  
  Frame3DGadget(1110, 10, 110, 300, 130, "Proprits")
  TextGadget(1119,0,130,100,20,"Nbre D'images : ", #PB_Text_Right) 
  ;StringGadget(1120, 130, 130, 55, 20, Str(Brush_nb_img), #PB_String_Numeric)
  SpinGadget(1120, 130, 130, 55, 20, 1, 100,#PB_Spin_Numeric)
  SetGadgetState(1120,Brush_nb_img)

  TextGadget(1121,0,155,100,20,"Vitesse : ", #PB_Text_Right) 
  ;StringGadget(1122, 130, 155, 55, 20, Str(Brush_speed), #PB_String_Numeric)      
  SpinGadget(1122, 130, 155, 55, 20, 1, 100,#PB_Spin_Numeric)
  SetGadgetState(1122,Brush_speed)
  
;   Frame3DGadget(1120, 10, 180, 300, 110, "Options")
;   OptionGadget(1121, 20,200,150,20,"Blanc")
;   OptionGadget(1127, 20,220,150,20,"Couleur d'arrire-plan")
;   OptionGadget(1123, 20,240,150,20,"Couleur d'avant-plan")
;   OptionGadget(1124, 20,260,150,20,"Transparent")
  
  ButtonGadget(1108,320,20,70,25,"Ok")
  ButtonGadget(1109,320,50,70,25,"Annuler")
  ;StickyWindow(118,1) 
   
  quitt.b  
  Repeat
    event2 = WaitWindowEvent()
    SetActiveWindow(118)
    
    Select event2
        
      Case #PB_Event_CloseWindow 
        If GetActiveWindow() <> 0         
          CloseWindow(GetActiveWindow())
          open_menu = 0
        EndIf
        
      Case #PB_Event_Gadget
        Select EventGadget()
            
          Case 1108
            CloseWindow(GetActiveWindow())
            quitt = 1
            
          Case 1109
            CloseWindow(GetActiveWindow())
            quitt = 1
            
        EndSelect    
        
    EndSelect
    
  Until quitt = 1 Or event2 = #PB_Event_CloseWindow 
  open_menu = 0
  firstopen = 1
EndProcedure
Procedure open_options()
  ; backgroundCanvas 
  new_window(118,"Options",400,300)
  pixel_x = 640
  pixel_y = 480
  reso = 72

  TextGadget(1112,100,10,50,20, "Nom :")
  StringGadget(1113,130, 7, 150, 20, "")
  
  TextGadget(1115,100,35,40,20,"Dossier: ") 
  StringGadget(1116, 160,  35, 120, 20, DirectoryBrush$)
  ButtonImageGadget(1118,280,35,20,20,ImageID(#Img_btn_newlayer))
  
  CheckBoxGadget(1114,100,55,80,20,"Preview Anim")
  CheckBoxGadget(1117,100,75,110,20,"Lecture Random")
  ;CheckBoxGadget(1122,100,70,100,20,"Brush anim")
  
  
  Frame3DGadget(1110, 10, 110, 300, 130, "Proprits")
  TextGadget(1119,0,130,100,20,"Nbre D'images : ", #PB_Text_Right) 
  ;StringGadget(1120, 130, 130, 55, 20, Str(Brush_nb_img), #PB_String_Numeric)
  SpinGadget(1120, 130, 130, 55, 20, 1, 100,#PB_Spin_Numeric)
  SetGadgetState(1120,Brush_nb_img)

  TextGadget(1121,0,155,100,20,"Vitesse : ", #PB_Text_Right) 
  ;StringGadget(1122, 130, 155, 55, 20, Str(Brush_speed), #PB_String_Numeric)      
  SpinGadget(1122, 130, 155, 55, 20, 1, 100,#PB_Spin_Numeric)
  SetGadgetState(1122,Brush_speed)
  
;   Frame3DGadget(1120, 10, 180, 300, 110, "Options")
;   OptionGadget(1121, 20,200,150,20,"Blanc")
;   OptionGadget(1127, 20,220,150,20,"Couleur d'arrire-plan")
;   OptionGadget(1123, 20,240,150,20,"Couleur d'avant-plan")
;   OptionGadget(1124, 20,260,150,20,"Transparent")
  
  ButtonGadget(1108,320,20,70,25,"Ok")
  ButtonGadget(1109,320,50,70,25,"Annuler")
  ;StickyWindow(118,1) 
   
  quitt.b  
  Repeat
    event2 = WaitWindowEvent()
    SetActiveWindow(118)
    
    Select event2
        
      Case #PB_Event_CloseWindow 
        If GetActiveWindow() <> 0         
          CloseWindow(GetActiveWindow())
          open_menu = 0
        EndIf
        
      Case #PB_Event_Gadget
        Select EventGadget()
            
          Case 1108
            CloseWindow(GetActiveWindow())
            quitt = 1
            
          Case 1109
            CloseWindow(GetActiveWindow())
            quitt = 1
            
        EndSelect    
        
    EndSelect
    
  Until quitt = 1 Or event2 = #PB_Event_CloseWindow 
  open_menu = 0
  firstopen = 1
EndProcedure



; canvas
Procedure zoom_canvas(mode=0, sens=1)  
  ; by kernadec, thanks !
  ; this procedure isn't finished and will change soon
  ; cette procedure n'est pas termine, elle bugue un peu et je vais la changer bientt 
  If mode = 0
    delta=delta+(GetGadgetAttribute(#canvas,#PB_Canvas_WheelDelta )*50) ; delta*10
  ElseIf mode = 1
    delta +50*sens
  EndIf  
  CopyImage(current_layer,#copy_currentlayer)      ; restore l'image originale  ; copy to keep the original image
  StartDrawing(ImageOutput(#copy_currentlayer))
  DrawingMode(#PB_2DDrawing_AllChannels)  
  DrawAlphaImage(GetGadgetAttribute(#canvas,#PB_Canvas_Image),0,0)
  StopDrawing()
  
  ResizeImage(#copy_currentlayer,(ImageWidth(#copy_currentlayer)-delta),(ImageHeight(#copy_currentlayer)-delta),#PB_Image_Raw)   
  If StartDrawing(CanvasOutput(#canvas))
    ;Box(-20,-20,WindowWidth(0)*2,WindowHeight(0)*2,RGB(255,255,255))
    If IsImage(#copy_currentlayer)             ; test image pour eviter bug
      DrawAlphaImage(ImageID(#copy_currentlayer),PosXm1+(delta/2),PosYm1+(delta/2))
    EndIf
    StopDrawing()
  EndIf
EndProcedure

; UI, interface
Procedure coloriz(couleur)
  color_R=Red(couleur)
  color_G=Green(couleur)
  color_B=Blue(couleur) 
EndProcedure
;}

;{ UPDATE
; update 
Procedure update_canvas()   
  StartDrawing(CanvasOutput(#canvas)) 
  DrawingMode(#PB_2DDrawing_Default)
  Box(0,0,doc_w,doc_h,RGBA(255,255,255,255)) 
  If backgroundCanvas = 1
    DrawImage(ImageID(#canvasBG),0,0)
  EndIf  
  DrawingMode(#PB_2DDrawing_AlphaBlend)
  ForEach layers()
    If layers()\visible = 1 And layers()\opacity >0
      DrawAlphaImage(ImageID(layers()\id),0,0,layers()\opacity)
    EndIf    
  Next
  StopDrawing()
EndProcedure
Procedure update_color()
  ; color select Front Ground color  (color_fg)
  If StartDrawing(ImageOutput(#previewcoloFG))
    Box(0,0,30,30,RGB(255,255,255))
    Box(1,1,28,28,color)
    StopDrawing()
  Else
    MessageRequester("Erreur","Impossible de dessiner sur l'image pour le preview color.",#MB_ICONERROR)
  EndIf
  ; color select BackGround color (color_bg)
  If StartDrawing(ImageOutput(#previewcolobG))
    Box(0,0,30,30,RGB(255,255,255))
    Box(1,1,28,28,colorQ)
    StopDrawing()
  Else
    MessageRequester("Erreur","Impossible de dessiner sur l'image pour le preview color.",#MB_ICONERROR)
  EndIf  
  If SetGadgetState(#IG_previewcoloBG,ImageID(#previewcoloBG)) : EndIf
  If SetGadgetState(#IG_previewcoloFG,ImageID(#previewcoloFG)) : EndIf
EndProcedure
Procedure update_preview()  
  CopyImage(#brush,#previewbrush1)
  CopyImage(#brush,#prviewBrush2)
  ResizeImage(#previewbrush1,preview_size,preview_size) 
  ResizeImage(#prviewBrush2,preview_size,preview_size) 
  StartDrawing(ImageOutput(#previewbrush1))
  DrawingMode(#PB_2DDrawing_AlphaChannel)
  Box(0,0,preview_size,preview_size,RGBA(15,15,15,255))
  DrawingMode(#PB_2DDrawing_Default)   
  Box(0,0,preview_size,preview_size,RGBA(125,125,125,0))
  DrawingMode(#PB_2DDrawing_AlphaBlend)    
  DrawImage(ImageID(#prviewBrush2),0,0)
  StopDrawing()  
  SetGadgetState(#IG_preview_brush,ImageID(#previewbrush1))  
EndProcedure
Procedure update_gadget()
  SetGadgetText(#text_option1, "Coords: "+Str(x_canvas)+","+Str(y_canvas));Str(xx)+","+Str(yy))
  SetGadgetText(#text_option2, " R : "+Str(colorselect_R) +" - G : "+Str(colorselect_G)+" - B : "+Str(colorselect_B) )
 ; SetGadgetText(#text_option2, "open_menu : "+Str(open_menu)+" / FirstOpen : "+Str(FirstOpen))
  SetGadgetText(#text_option3, " R : "+Str(colorpickerR) +" / G : "+Str(colorpickerG)+" / B : "+Str(colorpickerB) )  
EndProcedure
Procedure alarm()
  ;loop procedures
  ; to change the "viscosity"
  If visco_ok
    If viscosity >0
      If visco>-1
        visco - 1
      Else
        visco = viscosity
      EndIf  
    EndIf
  EndIf
EndProcedure


;}

;{ LAYERS & BLEND MODE...
; layers
Procedure new_layer() 
  AddElement(layers())  ; add a layer to the list (layer menu to clic, to block, see, change the blendmode..)
  AddElement(Image_layer()) ; add an image to the list (image to paint on)
  nb_layer = ListSize(layers())
  curpos_layer +1
  ; create the layer (menu)
  With layers()
    \id = 500+nb_layer
    current_layer = \id
    \blendmode = 0   
    \locked = 0
    \visible = 1
    \opacity = 255
    opac = Round(\opacity/2.55,#PB_Round_Nearest)
    SetGadgetState(#TB_Opac,opac)
    \position = curpos_layer
    \IG_LayerMenu  = 500 + nb_layer
    \name$ = "Layer" + Str(\id-500)    
  EndWith
  ; create the image (and the image gadget?) to paint on it
  With Image_layer()
    \id = 500 + nb_layer
    CreateImage(\id,doc_w,doc_h,32)
    StartDrawing(ImageOutput(\id))
    DrawingMode(#PB_2DDrawing_AlphaChannel)
    Box(0,0,doc_w,doc_h,RGBA(255,255,255,0))
    StopDrawing()
  EndWith  
  OpenGadgetList(#SA_Layer)
  layers_list()
  CloseGadgetList()     
  ; NOT FINISHED
  Debug current_layer
  
EndProcedure
Procedure delete_layer() 
  first_open = 1
  open_menu = 1
  If ListSize(layers())>1
    With layers()
      If IsGadget(\IG_LayerMenu)
        curpos_layer - 1
        current_layer - 1
        FreeGadget(\IG_LayerMenu)
        DeleteElement(layers(),1)
        DeleteElement(Image_layer(),1)       
        OpenGadgetList(#SA_Layer)
        layers_list()
        CloseGadgetList()
      EndIf
    EndWith
  Else
    MessageRequester("Erreur","Vous devez avoir plus d'un calque pour effectuer cette action.")    
  EndIf 
EndProcedure
Procedure move_layer(sens)
 Debug "move : " +Str(curpos_layer)
 ForEach layers() 
    With layers()  
      If \id = current_layer
        If \position>1 And \position < ListSize(layers())
          \position+*sens
          curpos_layer+*sens
        ElseIf \position = curpos_layer
          \position-sens
        EndIf      
      EndIf      
    EndWith
  Next

  OpenGadgetList(#SA_Layer)
  layers_list()
  CloseGadgetList()  
EndProcedure
Procedure layers_list()
  ForEach layers() 
    With layers()  
      If \id = current_layer
        StartDrawing(ImageOutput(#Img_Pan_LayerCenter))
        DrawingMode(#PB_2DDrawing_Default)  
        DrawImage(ImageID(#Img_Pan_FondLayerSel),0,0)
        If \visible =1
          DrawImage(ImageID(#Img_Pan_layerVue),5,8)
          paint_visible = 1
        Else
          paint_visible = 0
        EndIf 
        If \locked =1
          DrawImage(ImageID(#Img_Pan_LayerLock),120,6)
          paint_locked = 1
        Else
          paint_locked = 0
        EndIf 
        opac = Round(\opacity/2.55,#PB_Round_Nearest)
        SetGadgetState(#TB_Opac,opac)        

        DrawingMode(#PB_2DDrawing_Transparent)  
        DrawText(60,4,\name$)       
        StopDrawing()        
        ImageGadget(\IG_LayerMenu,0 ,1+26*(ListSize(layers())-\position),180,25,ImageID(#Img_Pan_LayerCenter))
      Else
        StartDrawing(ImageOutput(#Img_Pan_LayerCenterSel))
        DrawingMode(#PB_2DDrawing_AllChannels)  
        DrawImage(ImageID(#Img_Pan_FondLayer),0,0)
        DrawingMode(#PB_2DDrawing_AlphaBlend)  
        Box(0,0,200,42,RGBA(100,100,100,50))
        DrawingMode(#PB_2DDrawing_AlphaBlend)  
        If \visible =1
          DrawImage(ImageID(#Img_Pan_layerVue),5,8)
        EndIf 
        If \locked =1
          DrawImage(ImageID(#Img_Pan_LayerLock),120,6)
        EndIf 
        DrawingMode(#PB_2DDrawing_Transparent)  
        DrawText(60,4,\name$)       
        StopDrawing()  
        ImageGadget(\IG_LayerMenu,0 ,1+26*(ListSize(layers())-\position),180,25,ImageID(#Img_Pan_LayerCenterSel))        
      EndIf     
      ;SetGadgetData(\IG_LayerMenu,\IG_LayerMenu)
    EndWith 
    
  Next 
EndProcedure
Procedure update_layer()
    StartDrawing(ImageOutput(#Img_Pan_LayerCenter))
    DrawingMode(#PB_2DDrawing_Default)  
    DrawImage(ImageID(#Img_Pan_FondLayerSel),0,0)
    If layers()\visible =1
      DrawImage(ImageID(#Img_Pan_layerVue),5,8)
    EndIf 
    If layers()\locked =1
      DrawImage(ImageID(#Img_Pan_LayerLock),5,8)
    EndIf 
    DrawingMode(#PB_2DDrawing_Transparent)  
    DrawText(60,4,layers()\name$)       
    StopDrawing()        
    ImageGadget(layers()\IG_LayerMenu,0 ,1+26*(ListSize(layers())-layers()\position),180,25,ImageID(#Img_Pan_LayerCenter))
EndProcedure
;}

;{ BRUSH & TOOLS
; brush
Procedure brushDirectory()
  brush_nb =0
  Debug DirectoryBrush$
  If ExamineDirectory(0, DirectoryBrush$, "*.png")  
    While NextDirectoryEntry(0)
      If DirectoryEntryType(0) = #PB_DirectoryEntry_File
        brush_nb+1         
      EndIf
    Wend
    FinishDirectory(0)
  EndIf
  Debug brush_nb
EndProcedure
Procedure paint_brush()   
  CopyImage(#brush,#brushcopy2) ; on copie le brush pour travailler sans modifier l'origine //copy of the brush to not change the original brush 
  ;rotation = RotateImageEx2(ImageID(7),Brush_Rotation)
  sizw =Round(size*sizeW/100,#PB_Round_Nearest)
  ResizeImage(#brushcopy2,sizw,Round(size*sizeH/100,#PB_Round_Nearest)) ;on modifie la taille du brush// we modify the size of the brush

  StartDrawing(ImageOutput(#brushcopy2))     
  For y=0 To ImageHeight(#brushcopy2)-1
    For x=0 To ImageWidth(#brushcopy2)-1  
      DrawingMode(#PB_2DDrawing_AlphaChannel)
      alpha_point = Alpha(Point(x,y))-(255-transparence) ;on rcupre l'alpha du brush (pixel par pixel) qu'on modifie par la valeur transparence//we have the alpha of the brush (by pixel) we modify its transparency
      If alpha_point<0
        alpha_point = 0
      EndIf
      DrawingMode(#PB_2DDrawing_AllChannels)
      Plot(x,y,RGBA(Red(colorQ), Green(colorQ),Blue(colorQ),alpha_point)) ; on redessine chaque point par la nouvelle couleur et l'alpha modifie / we redraw each point with the new color and alpha
    Next x
  Next y 
  StopDrawing()
EndProcedure

; transform - brush
Procedure.l RotateImageEx2(ImageID, Angle.f, Mode.l=2) ; Rotation d'une image d'un angle en  - rotation of an image, in degres.
  ; Procedure par Le Soldat inconnu - Merci 
  Protected bmi.BITMAPINFO, bmi2.BITMAPINFO, hdc.l, NewImageID, Mem, n, nn, bm.BITMAP
  
  Angle = Angle * #PI / 180 ; On convertit en radian
  
  Cos.f = Cos(Angle)
  Sin.f = Sin(Angle)
  
  CouleurFond = 0
  
  GetObject_(ImageID, SizeOf(BITMAP), @bm.BITMAP) ; windows only; is there a version for linux, mac os ?
  
  bmi\bmiHeader\biSize = SizeOf(BITMAPINFOHEADER)
  bmi\bmiHeader\biWidth = bm\bmWidth
  bmi\bmiHeader\biHeight = bm\bmHeight
  bmi\bmiHeader\biPlanes = 1
  bmi\bmiHeader\biBitCount = 32
  
  bmi2\bmiHeader\biSize = SizeOf(BITMAPINFOHEADER)
  ;    Select Mode
  ;       Case 1
  ;          bmi2\bmiHeader\biWidth = bm\bmWidth
  ;          bmi2\bmiHeader\biHeight = bm\bmHeight
  ;       Case 2
  bmi2\bmiHeader\biWidth = Round(Sqr(bm\bmWidth * bm\bmWidth + bm\bmHeight * bm\bmHeight), 1)
  bmi2\bmiHeader\biHeight = bmi2\bmiHeader\biWidth
  ;       Default
  ;          bmi2\bmiHeader\biWidth = Round(bm\bmWidth * Abs(Cos) + bm\bmHeight * Abs(Sin), 1)
  ;          bmi2\bmiHeader\biHeight = Round(bm\bmHeight * Abs(Cos) + bm\bmWidth * Abs(Sin), 1)
  ;    EndSelect
  bmi2\bmiHeader\biPlanes = 1
  bmi2\bmiHeader\biBitCount = 32
  
  Mem = AllocateMemory(bm\bmWidth * bm\bmHeight * 4)
  If Mem
    Mem2 = AllocateMemory(bmi2\bmiHeader\biWidth * bmi2\bmiHeader\biHeight * 4)
    If Mem2
      
      hdc = CreateCompatibleDC_(GetDC_(ImageID)) ; windows only
      If hdc
        GetDIBits_(hdc, ImageID, 0, bm\bmHeight, Mem, @bmi, #DIB_RGB_COLORS) ; on envoie la liste dans l'image / windows only
        DeleteDC_(hdc) ; windows only
      EndIf
      
      CX1 = bm\bmWidth - 1
      CY1 = bm\bmHeight - 1
      CX2 = bmi2\bmiHeader\biWidth - 1
      CY2 = bmi2\bmiHeader\biHeight - 1
      
      Mem01 = Mem + bm\bmWidth * 4
      Mem10 = Mem + 4
      Mem11 = Mem01 + 4
      
      Mem2Temp = Mem2
      
      For nn = 0 To CY2
        y1b.l = nn * 2 - CY2
        Temp1.f = CX1 - y1b * Sin
        Temp2.f = CY1 + y1b * Cos
        For n = 0 To CX2
          x1b.l = n * 2 - CX2
          
          x1.f = (Temp1 + x1b * Cos) / 2
          y1.f = (Temp2 + x1b * Sin) / 2
          
          x2.l = x1
          y2.l = y1
          
          If x1 < x2
            x2 - 1
          EndIf
          If y1 < y2
            y2 - 1
          EndIf
          
          x2b = x2 + 1
          y2b = y2 + 1
          
          If x2b >= 0 And x2 <= CX1 And y2b >= 0 And y2 <= CY1 ; On filtre si on est completement en dehors de l'image
            
            fx.f = x1 - x2
            fy.f = y1 - y2
            f00.f = (1 - fx) * (1 - fy)
            f01.f = (1 - fx) * fy
            f10.f = fx * (1 - fy)
            f11.f = fx * fy
            
            MemTemp = (x2 + y2 * bm\bmWidth) * 4
            
            If x2 >= 0 And x2 <= CX1
              If y2 >= 0 And y2 <= CY1
                c00 = PeekL(Mem + MemTemp)
              Else
                c00 = 0
              EndIf
              If y2b >= 0 And y2b <= CY1
                c01 = PeekL(Mem01 + MemTemp)
              Else
                c01 = 0
              EndIf
            Else
              c00 = 0
              c01 = 0
            EndIf
            If x2b >= 0 And x2b <= CX1
              If y2 >= 0 And y2 <= CY1
                c10 = PeekL(Mem10 + MemTemp)
              Else
                c10 = 0
              EndIf
              If y2b >= 0 And y2b <= CY1
                c11 = PeekL(Mem11 + MemTemp)
              Else
                c11 = 0
              EndIf
            Else
              c10 = 0
              c11 = 0
            EndIf
            
            Channel00 = c00 >> 24 & $FF
            Channel01 = c01 >> 24 & $FF
            Channel10 = c10 >> 24 & $FF
            Channel11 = c11 >> 24 & $FF
            Alpha = Channel00 * f00 + Channel01 * f01 + Channel10 * f10 + Channel11 * f11
            
            Channel00 = c00 >> 16 & $FF
            Channel01 = c01 >> 16 & $FF
            Channel10 = c10 >> 16 & $FF
            Channel11 = c11 >> 16 & $FF
            Bleu = Channel00 * f00 + Channel01 * f01 + Channel10 * f10 + Channel11 * f11
            
            Channel00 = c00 >> 8 & $FF
            Channel01 = c01 >> 8 & $FF
            Channel10 = c10 >> 8 & $FF
            Channel11 = c11 >> 8 & $FF
            Vert = Channel00 * f00 + Channel01 * f01 + Channel10 * f10 + Channel11 * f11
            
            Channel00 = c00 & $FF
            Channel01 = c01 & $FF
            Channel10 = c10 & $FF
            Channel11 = c11 & $FF
            Rouge  = Channel00 * f00 + Channel01 * f01 + Channel10 * f10 + Channel11 * f11
            
            PokeL(Mem2Temp, Rouge | Vert << 8 | Bleu  << 16 | Alpha << 24)
            
          Else
            PokeL(Mem2Temp, 0)
          EndIf
          
          Mem2Temp + 4
          
        Next
      Next
      
      ; On cre la nouvelle image
      NewImageID = CreateImage(#PB_Any, bmi2\bmiHeader\biWidth, bmi2\bmiHeader\biHeight, 32)
      hdc = CreateCompatibleDC_(GetDC_(ImageID(NewImageID)))
      If hdc
        SetDIBits_(hdc, ImageID(NewImageID), 0, bmi2\bmiHeader\biHeight, Mem2, @bmi2, #DIB_RGB_COLORS) ; on envoie la liste dans l'image
        DeleteDC_(hdc)
      EndIf
      
      FreeMemory(Mem2)
    EndIf
    FreeMemory(Mem)
  EndIf
  
  ProcedureReturn NewImageID
EndProcedure
Procedure random_resize() 
  minisiz=Round(size*size_mini/100,1)
  siz =minisiz+Random(size-minisiz)*(1-random_size) + random_size*(size-minisiz)
  CopyImage(#brushcopy2,#pbrush)
  ResizeImage(#pbrush,Round(siz*sizeW/100,#PB_Round_Nearest),Round(siz*sizeH/100,#PB_Round_Nearest),0)
EndProcedure

; brush - drawing
Procedure DrawBrush(xpos,ypos)
  If mouseincanvas=1 And tool = 1 
    random_resize()  
    If random_rotation = 1
      r=Round(Random(360),0)
      rotation = RotateImageEx2(ImageID(#pbrush),r)
      x1 = ImageWidth(rotation)/2
      y1 = ImageHeight(rotation)/2   
    ElseIf random_rotation = 0 And Brush_Rotation>0
      rotation = RotateImageEx2(ImageID(#pbrush),Brush_Rotation)
      x1 = ImageWidth(#pbrush)/2
      y1 = ImageHeight(#pbrush)/2   
    ElseIf random_rotation = 0 And Brush_Rotation =0
      rotation = #pbrush
      x1 = ImageWidth(#pbrush)/2
      y1 = ImageHeight(#pbrush)/2   
    EndIf
    
    
    If visco <1  And visco_ok      
      If mix_ok 
        StartDrawing(CanvasOutput(#canvas))  
        colorselect_R = Red(Point(x_canvas,y_canvas))
        colorselect_G = Green(Point(x_canvas,y_canvas))
        colorselect_B = Blue(Point(x_canvas,y_canvas))
        newcolor = RGB(colorselect_R,colorselect_G,colorselect_B);         
        colorQ = ColorBlending(color, newcolor, mix)
        color_R =Red(colorQ)
        color_G =Green(colorQ)
        color_B=Blue(colorQ)
        StopDrawing() 
      EndIf       
    EndIf

;     DrawAlphaImage(ImageID(#canvasBG),0,0) 
;     DrawingMode(#PB_2DDrawing_AlphaBlend)   
;     DrawAlphaImage(ImageID(rotation),xpos-x1,ypos-y1,transparence)
;     DrawAlphaImage(ImageID(5),xpos-x1,ypos-y1,transparence)

    StartDrawing(ImageOutput(current_layer))  
    DrawingMode(#PB_2DDrawing_AlphaBlend)   
    DrawAlphaImage(ImageID(rotation),xpos-x1-marge/2-15,ypos-y1-marge/2,transparence)
    StopDrawing()
    
    If random_rotation
      FreeImage(rotation)
    EndIf    
    If mix_ok
      paint_brush()
    EndIf  
    update_canvas()
  EndIf
EndProcedure
Procedure EraseBrush2(can,xpos,ypos)
  If mouseincanvas=1    
    random_resize()         
    r=Round(Random(360),0)
    rotation = RotateImageEx2(ImageID(#pbrush),r)
    x1 = ImageWidth(rotation)/2
    y1 = ImageHeight(rotation)/2 
    
    StartDrawing(ImageOutput(100)) 
    DrawingMode(#PB_2DDrawing_AlphaChannel)
    DrawAlphaImage(ImageID(rotation),xpos-x1,ypos-y1,transparence)
    StopDrawing()
    
    ;SetGadgetState(igad,ImageID(can))
    update_canvas()   
    FreeImage(rotation)
  EndIf
EndProcedure
Procedure Clear_Canvas(can,r,g,b)
  ; by syntax error, thanks
  Static bkgcolor
  bkgcolor=RGB(r,g,b)  
  StartDrawing(ImageOutput(current_layer))
  DrawingMode(#PB_2DDrawing_AlphaChannel)
  Box(0,0,doc_w+5,doc_h+5,RGBA(0,0,0,0)) 
  StopDrawing()
  update_canvas()

EndProcedure 
ProcedureDLL.l ColorBlending(Couleur1.l, Couleur2.l, Echelle.f) ; Mlanger 2 couleurs//to mix 2 colors
  ; by Le soldat inconnu, thanks !
  
  Protected Rouge, Vert, Bleu, Rouge2, Vert2, Bleu2
  
  Rouge = Couleur1 & $FF
  Vert = Couleur1 >> 8 & $FF
  Bleu = Couleur1 >> 16
  Rouge2 = Couleur2 & $FF
  Vert2 = Couleur2 >> 8 & $FF
  Bleu2 = Couleur2 >> 16
  
  Rouge = Rouge * Echelle + Rouge2 * (1-Echelle)
  Vert = Vert * Echelle + Vert2 * (1-Echelle)
  Bleu = Bleu * Echelle + Bleu2 * (1-Echelle)
  
  ProcedureReturn (Rouge | Vert <<8 | Bleu << 16)
EndProcedure

;eraser
Procedure Filtre_MelangeAlpha(x, y, CouleurSource, CouleurDestination) ; filter To mix alpha, for the eraser
   ProcedureReturn (CouleurDestination & $00FFFFFF) | (Alpha(CouleurSource)*Alpha(CouleurDestination)/255)<<24
 EndProcedure
Procedure Filtre_MelangeAlpha2(x, y, CouleurSource, CouleurDestination) ;; filter To mix alpha for the eraser tool
   ; By Le Soldat inconnu
   ; modif by blendman
  If Alpha(CouleurDestination)-Alpha(CouleurSource)>=0    
    ProcedureReturn RGBA(Red(CouleurDestination), Green(CouleurDestination), Blue(CouleurDestination), Alpha(CouleurDestination)-Alpha(CouleurSource))
  Else
    ProcedureReturn RGBA(Red(CouleurDestination), Green(CouleurDestination), Blue(CouleurDestination), 0)
  EndIf
EndProcedure
Procedure EraseBrush(xpos,ypos)
  If open_menu = 0
    random_resize()         
    If tool = 2; brush eraser
      r=Round(Random(360),0)
      rotation = RotateImageEx2(ImageID(#pbrush),r)
      If random_rotation = 1
        r=Round(Random(360),0)
        rotation = RotateImageEx2(ImageID(#pbrush),r)
        x1 = ImageWidth(rotation)/2
        y1 = ImageHeight(rotation)/2   
      ElseIf random_rotation = 0 And Brush_Rotation>0
        rotation = RotateImageEx2(ImageID(#pbrush),Brush_Rotation)
        x1 = ImageWidth(#pbrush)/2
        y1 = ImageHeight(#pbrush)/2   
      ElseIf random_rotation = 0 And Brush_Rotation =0
        rotation = #pbrush
        x1 = ImageWidth(#pbrush)/2
        y1 = ImageHeight(#pbrush)/2   
      EndIf  
      StartDrawing(ImageOutput(current_layer))
      DrawingMode(#PB_2DDrawing_CustomFilter)
      CustomFilterCallback(@Filtre_MelangeAlpha2())      
      DrawAlphaImage(ImageID(rotation),xpos-x1-marge/2,ypos-y1-marge/2,alpha_eraser) 
    ElseIf tool = 0 ; circle eraser
      StartDrawing(ImageOutput(current_layer))
      DrawingMode(#PB_2DDrawing_CustomFilter)
      CustomFilterCallback(@Filtre_MelangeAlpha()) 
      Circle(xpos-marge/2-rayon/2,ypos-marge/2-rayon/2,rayon,RGBA(0,0,0,255-alpha_eraser)) 
    EndIf
    
    StopDrawing()
    
    update_canvas()  
    FreeImage(rotation)
  EndIf
EndProcedure

;}


; IDE Options = PureBasic 4.60 RC 2 (Windows - x86)
; CursorPosition = 788
; Folding = AAAAAABBA-
; EnableXP